mod Ul04

incl Mtex

incl Mtexpl

incl Maux

loc rem 
  \para \bf  PREMIOVA ULOHA Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE 
   \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 29.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie niektorych funkcii 
         a predikatov. 
   \item \para Subor \it  ul*.cl  \end obsahuje priklady, ktore mate vyriesit v 
         tejto premiovej ulohe. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohu: \bf  \it  5  \end  \end. 
   \item \para Hodnoti sa len kompletne vyriesena uloha. 
   \item \para Ulohy rieste \bf  \it  samostatne!  \end  \end 
  \end
  \para Ulohu treba odovzdat do 5.5.2008 (pondelok) do 14:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Propositional Logic.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Dprf 'Tex_f1_f' \end Define the 
  function \ft Dprf(a) \end such that 
  \eq* 
    Form(a) & v in Dprf(a) -> ~True(v,a)
  \end
  \eq* 
    Form(a) & ~Taut(a) -> Dprf(a) != 0
  \end
  \para Note that we then have 
  \eq* 
    Form(a) -> Taut(a) <-> Dprf(a) = 0
  \end
  \eq* 
    Form(a) -> ~Taut(a) <-> Dprf(a) != 0
  \end

fun Dprf 'Tex_f1_f'
  Dprf(a) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc rem 
  \para The following formulas are tautologies: 

loc fun/0 A1 
  A1 = Imp(Pvar(1),Imp(Pvar(2),Pvar(1)))

loc fun/0 A2 
  A2 = Imp(And(Imp(Pvar(1),Pvar(2)),Imp(Pvar(2),Pvar(3))),Imp(Pvar(1),Pvar(3)))

loc fun/0 A3 
  A3 = 
  Imp(And(And(Imp(Pvar(1),Pvar(3)),Imp(Pvar(2),Pvar(3))),Or(Pvar(1),Pvar(2))),
      Pvar(3))

loc fun/0 A4 
  A4 = Iff(Not Imp(Pvar(1),Pvar(2)),And(Pvar(1),Not Pvar(2)))

loc fun/0 A5 
  A5 = 
  Iff(Or(Pvar(1),And(Pvar(2),Pvar(3))),
      And(Or(Pvar(1),Pvar(2)),Or(Pvar(1),Pvar(3))))

loc rem 
  \para and the following are not: 

loc fun/0 B1 
  B1 = 
  Imp(Imp(And(Pvar(1),Pvar(2)),Pvar(3)),
      And(Imp(Pvar(1),Pvar(3)),Imp(Pvar(2),Pvar(3))))

loc fun/0 B2 
  B2 = Imp(Or(Pvar(1),Pvar(2)),And(Pvar(1),Pvar(2)))

loc fun/0 B3 
  B3 = Imp(Imp(Pvar(1),Pvar(2)),Imp(Not Pvar(1),Not Pvar(2)))

